//
//  AD7490
//
#ifndef _AD7490_H
#define _AD7490_H

class AD7490 {
  protected:
    #define CREG_WRITE    0x800
    #define CREG_SEQ      0x400
    #define CREG_ADD3     0x200
    #define CREG_ADD2     0x100
    #define CREG_ADD1     0x080
    #define CREG_ADD0     0x040
    #define CREG_PM1      0x020
    #define CREG_PM0      0x010
    #define CREG_SHADOW   0x008
    #define CREG_WEAK     0x004
    #define CREG_RANGE    0x002
    #define CREG_CODING   0x001

    SPI spi;
    DigitalOut cs;
    short ret;
    
  public:
    AD7490(SPI _spi, PinName _cs);
    ~AD7490();
    unsigned short convert(int ch=0);
    void convert(short data[]);    

    unsigned short sequential(int ch=15);
    unsigned short read(void);
    void read(short data[]);
};


#if 0
int main() {

    wait(1);

    // set up SPI interface
    SPI spi(p11,p12,p13);
    spi.format(16,0);
    spi.frequency(1000000);

    AD7490 ad1(spi, p9);
    AD7490 ad2(spi, p10);

    while(1) {

        int ret=0;
        for(int ch=0; ch<16; ch++){
            ret = ad1.convert(ch);
            printf("ch=%2d, ret= %d, %f\n", (ret>>12)&0xF, ret&0xFFF, 3.3*(float)(ret&0xFFF)/0xFFF);
        }
        printf("\n");
        for(int ch=0; ch<16; ch++){
            ret = ad2.convert(ch);
            printf("ch=%2d, ret= %d, %f\n", (ret>>12)&0xF, ret&0xFFF, 3.3*(float)(ret&0xFFF)/0xFFF);
        }
        printf("\n");

        myled = 1;
        wait(0.1);
        myled = 0;
        wait(0.9);
    }
}
#endif  // test main

#endif  // _AD7490_H
